/* Utils.c generated by valac 0.42.2, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <meta/window.h>
#include <libbamf/libbamf.h>
#include <gio/gdesktopappinfo.h>
#include <plank.h>
#include <gio/gio.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <meta/boxes.h>
#include <clutter/clutter.h>
#include <meta/meta-shaped-texture.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>
#include <meta/compositor.h>
#include <meta/meta-backend.h>
#include <meta/main.h>
#include <meta/meta-settings.h>
#include <config.h>
#include <gobject/gvaluecollector.h>


#define GALA_TYPE_UTILS (gala_utils_get_type ())
#define GALA_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_UTILS, GalaUtils))
#define GALA_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_UTILS, GalaUtilsClass))
#define GALA_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_UTILS))
#define GALA_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_UTILS))
#define GALA_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_UTILS, GalaUtilsClass))

typedef struct _GalaUtils GalaUtils;
typedef struct _GalaUtilsClass GalaUtilsClass;
typedef struct _GalaUtilsPrivate GalaUtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _GalaParamSpecUtils GalaParamSpecUtils;

struct _GalaUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaUtilsPrivate * priv;
};

struct _GalaUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GalaUtils *self);
};

struct _Block1Data {
	int _ref_count_;
	guint32* xids;
	gint xids_length1;
};

struct _Block2Data {
	int _ref_count_;
	cairo_surface_t* surface;
};

struct _GalaParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer gala_utils_parent_class = NULL;
static GHashTable* gala_utils_xid_pixbuf_cache;
static GHashTable* gala_utils_xid_pixbuf_cache = NULL;
static GHashTable* gala_utils_icon_pixbuf_cache;
static GHashTable* gala_utils_icon_pixbuf_cache = NULL;
static guint gala_utils_cache_clear_timeout;
static guint gala_utils_cache_clear_timeout = (guint) 0;
static GdkPixbuf* gala_utils_close_pixbuf;
static GdkPixbuf* gala_utils_close_pixbuf = NULL;
static GdkPixbuf* gala_utils_resize_pixbuf;
static GdkPixbuf* gala_utils_resize_pixbuf = NULL;

gpointer gala_utils_ref (gpointer instance);
void gala_utils_unref (gpointer instance);
GParamSpec* gala_param_spec_utils (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void gala_value_set_utils (GValue* value,
                           gpointer v_object);
void gala_value_take_utils (GValue* value,
                            gpointer v_object);
gpointer gala_value_get_utils (const GValue* value);
GType gala_utils_get_type (void) G_GNUC_CONST;
static GalaUtils* gala_utils_new (void);
static GalaUtils* gala_utils_construct (GType object_type);
static void gala_utils_clean_icon_cache (guint32* xids,
                                  int xids_length1);
static gboolean _vala_uint32_array_contains (guint32 * stack,
                                      int stack_length,
                                      guint32 needle);
void gala_utils_request_clean_icon_cache (guint32* xids,
                                          int xids_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean __lambda6_ (Block1Data* _data1_);
static gboolean ___lambda6__gsource_func (gpointer self);
static gboolean ___lambda5__gsource_func (gpointer self);
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window,
                                           gint size,
                                           gint scale,
                                           gboolean ignore_cache);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid,
                                        gint size,
                                        gint scale,
                                        gboolean ignore_cache);
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app,
                                                gint size,
                                                gint scale,
                                                gboolean ignore_cache);
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace,
                                        gboolean backward);
guint gala_utils_get_n_windows (MetaWorkspace* workspace);
ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor,
                                                    MetaRectangle* inner_rect,
                                                    MetaRectangle* outer_rect);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block2Data* _data2_,
                     cairo_t* cr);
static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender,
                                          cairo_t* cr,
                                          gint width,
                                          gint height,
                                          gpointer self);
void gala_utils_bell (MetaScreen* screen);
GdkPixbuf* gala_utils_get_close_button_pixbuf (void);
ClutterActor* gala_utils_create_close_button (void);
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void);
ClutterActor* gala_utils_create_resize_button (void);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void gala_utils_finalize (GalaUtils * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GalaUtils*
gala_utils_construct (GType object_type)
{
	GalaUtils* self = NULL;
#line 36 "../lib/Utils.vala"
	self = (GalaUtils*) g_type_create_instance (object_type);
#line 36 "../lib/Utils.vala"
	return self;
#line 192 "Utils.c"
}


static GalaUtils*
gala_utils_new (void)
{
#line 36 "../lib/Utils.vala"
	return gala_utils_construct (GALA_TYPE_UTILS);
#line 201 "Utils.c"
}


/**
 * Clean icon caches
 */
static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	_tmp0_ = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	result = _tmp0_;
#line 783 "glib-2.0.vapi"
	return result;
#line 221 "Utils.c"
}


static gboolean
_vala_uint32_array_contains (guint32 * stack,
                             int stack_length,
                             guint32 needle)
{
	int i;
#line 51 "../lib/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 51 "../lib/Utils.vala"
		if (needle == stack[i]) {
#line 51 "../lib/Utils.vala"
			return TRUE;
#line 237 "Utils.c"
		}
	}
#line 51 "../lib/Utils.vala"
	return FALSE;
#line 242 "Utils.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../lib/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 251 "Utils.c"
}


static void
gala_utils_clean_icon_cache (guint32* xids,
                             int xids_length1)
{
	GList* list = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* pixbuf_list = NULL;
	GHashTable* _tmp2_;
	GList* _tmp3_;
	GList* icon_list = NULL;
	GHashTable* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
#line 45 "../lib/Utils.vala"
	_tmp0_ = gala_utils_xid_pixbuf_cache;
#line 45 "../lib/Utils.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 45 "../lib/Utils.vala"
	list = _tmp1_;
#line 46 "../lib/Utils.vala"
	_tmp2_ = gala_utils_icon_pixbuf_cache;
#line 46 "../lib/Utils.vala"
	_tmp3_ = g_hash_table_get_values (_tmp2_);
#line 46 "../lib/Utils.vala"
	pixbuf_list = _tmp3_;
#line 47 "../lib/Utils.vala"
	_tmp4_ = gala_utils_icon_pixbuf_cache;
#line 47 "../lib/Utils.vala"
	_tmp5_ = g_hash_table_get_keys (_tmp4_);
#line 47 "../lib/Utils.vala"
	icon_list = _tmp5_;
#line 49 "../lib/Utils.vala"
	_tmp6_ = list;
#line 289 "Utils.c"
	{
		GList* xid_key_collection = NULL;
		GList* xid_key_it = NULL;
#line 49 "../lib/Utils.vala"
		xid_key_collection = _tmp6_;
#line 49 "../lib/Utils.vala"
		for (xid_key_it = xid_key_collection; xid_key_it != NULL; xid_key_it = xid_key_it->next) {
#line 297 "Utils.c"
			const gchar* xid_key = NULL;
#line 49 "../lib/Utils.vala"
			xid_key = (const gchar*) xid_key_it->data;
#line 301 "Utils.c"
			{
				guint32 xid = 0U;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				guint32 _tmp12_;
				guint32 _tmp13_;
#line 50 "../lib/Utils.vala"
				_tmp7_ = xid_key;
#line 50 "../lib/Utils.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "::", 0);
#line 50 "../lib/Utils.vala"
				_tmp10_ = _tmp9_;
#line 50 "../lib/Utils.vala"
				_tmp10__length1 = _vala_array_length (_tmp8_);
#line 50 "../lib/Utils.vala"
				_tmp11_ = _tmp10_[0];
#line 50 "../lib/Utils.vala"
				_tmp12_ = (guint32) uint64_parse (_tmp11_);
#line 50 "../lib/Utils.vala"
				_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 50 "../lib/Utils.vala"
				xid = _tmp12_;
#line 51 "../lib/Utils.vala"
				_tmp13_ = xid;
#line 51 "../lib/Utils.vala"
				if (!_vala_uint32_array_contains (xids, xids_length1, _tmp13_)) {
#line 332 "Utils.c"
					GdkPixbuf* pixbuf = NULL;
					GHashTable* _tmp14_;
					const gchar* _tmp15_;
					gconstpointer _tmp16_;
					GdkPixbuf* _tmp17_;
					GHashTable* _tmp30_;
					const gchar* _tmp31_;
#line 52 "../lib/Utils.vala"
					_tmp14_ = gala_utils_xid_pixbuf_cache;
#line 52 "../lib/Utils.vala"
					_tmp15_ = xid_key;
#line 52 "../lib/Utils.vala"
					_tmp16_ = g_hash_table_lookup (_tmp14_, _tmp15_);
#line 52 "../lib/Utils.vala"
					_tmp17_ = _g_object_ref0 ((GdkPixbuf*) _tmp16_);
#line 52 "../lib/Utils.vala"
					pixbuf = _tmp17_;
#line 350 "Utils.c"
					{
						gint j = 0;
#line 53 "../lib/Utils.vala"
						j = 0;
#line 355 "Utils.c"
						{
							gboolean _tmp18_ = FALSE;
#line 53 "../lib/Utils.vala"
							_tmp18_ = TRUE;
#line 53 "../lib/Utils.vala"
							while (TRUE) {
#line 362 "Utils.c"
								gint _tmp20_;
								GList* _tmp21_;
								GList* _tmp22_;
								gint _tmp23_;
								gconstpointer _tmp24_;
								GdkPixbuf* _tmp25_;
#line 53 "../lib/Utils.vala"
								if (!_tmp18_) {
#line 371 "Utils.c"
									gint _tmp19_;
#line 53 "../lib/Utils.vala"
									_tmp19_ = j;
#line 53 "../lib/Utils.vala"
									j = _tmp19_ + 1;
#line 377 "Utils.c"
								}
#line 53 "../lib/Utils.vala"
								_tmp18_ = FALSE;
#line 53 "../lib/Utils.vala"
								_tmp20_ = j;
#line 53 "../lib/Utils.vala"
								_tmp21_ = pixbuf_list;
#line 53 "../lib/Utils.vala"
								if (!(((guint) _tmp20_) < g_list_length (_tmp21_))) {
#line 53 "../lib/Utils.vala"
									break;
#line 389 "Utils.c"
								}
#line 54 "../lib/Utils.vala"
								_tmp22_ = pixbuf_list;
#line 54 "../lib/Utils.vala"
								_tmp23_ = j;
#line 54 "../lib/Utils.vala"
								_tmp24_ = g_list_nth_data (_tmp22_, (guint) _tmp23_);
#line 54 "../lib/Utils.vala"
								_tmp25_ = pixbuf;
#line 54 "../lib/Utils.vala"
								if (((GdkPixbuf*) _tmp24_) == _tmp25_) {
#line 401 "Utils.c"
									GHashTable* _tmp26_;
									GList* _tmp27_;
									gint _tmp28_;
									gconstpointer _tmp29_;
#line 55 "../lib/Utils.vala"
									_tmp26_ = gala_utils_xid_pixbuf_cache;
#line 55 "../lib/Utils.vala"
									_tmp27_ = icon_list;
#line 55 "../lib/Utils.vala"
									_tmp28_ = j;
#line 55 "../lib/Utils.vala"
									_tmp29_ = g_list_nth_data (_tmp27_, (guint) _tmp28_);
#line 55 "../lib/Utils.vala"
									g_hash_table_remove (_tmp26_, (const gchar*) _tmp29_);
#line 416 "Utils.c"
								}
							}
						}
					}
#line 59 "../lib/Utils.vala"
					_tmp30_ = gala_utils_xid_pixbuf_cache;
#line 59 "../lib/Utils.vala"
					_tmp31_ = xid_key;
#line 59 "../lib/Utils.vala"
					g_hash_table_remove (_tmp30_, _tmp31_);
#line 51 "../lib/Utils.vala"
					_g_object_unref0 (pixbuf);
#line 429 "Utils.c"
				}
			}
		}
	}
#line 43 "../lib/Utils.vala"
	(icon_list == NULL) ? NULL : (icon_list = (g_list_free (icon_list), NULL));
#line 43 "../lib/Utils.vala"
	(pixbuf_list == NULL) ? NULL : (pixbuf_list = (g_list_free (pixbuf_list), NULL));
#line 43 "../lib/Utils.vala"
	(list == NULL) ? NULL : (list = (g_list_free (list), NULL));
#line 440 "Utils.c"
}


/**
 * Marks the given xids as no longer needed, the corresponding icons
 * may be freed now. Mainly for internal purposes.
 *
 * @param xids The xids of the window that no longer need icons
 */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 70 "../lib/Utils.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 70 "../lib/Utils.vala"
	return _data1_;
#line 457 "Utils.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 70 "../lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 70 "../lib/Utils.vala"
		g_slice_free (Block1Data, _data1_);
#line 470 "Utils.c"
	}
}


static gboolean
__lambda6_ (Block1Data* _data1_)
{
	gboolean result = FALSE;
#line 78 "../lib/Utils.vala"
	gala_utils_clean_icon_cache (_data1_->xids, _data1_->xids_length1);
#line 79 "../lib/Utils.vala"
	result = FALSE;
#line 79 "../lib/Utils.vala"
	return result;
#line 485 "Utils.c"
}


static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
#line 77 "../lib/Utils.vala"
	return result;
#line 496 "Utils.c"
}


static gboolean
__lambda5_ (Block1Data* _data1_)
{
	gboolean result = FALSE;
#line 76 "../lib/Utils.vala"
	gala_utils_cache_clear_timeout = (guint) 0;
#line 77 "../lib/Utils.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 81 "../lib/Utils.vala"
	result = FALSE;
#line 81 "../lib/Utils.vala"
	return result;
#line 512 "Utils.c"
}


static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
#line 75 "../lib/Utils.vala"
	return result;
#line 523 "Utils.c"
}


void
gala_utils_request_clean_icon_cache (guint32* xids,
                                     int xids_length1)
{
	Block1Data* _data1_;
	guint _tmp0_;
#line 70 "../lib/Utils.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 70 "../lib/Utils.vala"
	_data1_->_ref_count_ = 1;
#line 70 "../lib/Utils.vala"
	_data1_->xids = xids;
#line 70 "../lib/Utils.vala"
	_data1_->xids_length1 = xids_length1;
#line 72 "../lib/Utils.vala"
	_tmp0_ = gala_utils_cache_clear_timeout;
#line 72 "../lib/Utils.vala"
	if (_tmp0_ > ((guint) 0)) {
#line 545 "Utils.c"
		guint _tmp1_;
#line 73 "../lib/Utils.vala"
		_tmp1_ = gala_utils_cache_clear_timeout;
#line 73 "../lib/Utils.vala"
		g_source_remove (_tmp1_);
#line 551 "Utils.c"
	}
#line 75 "../lib/Utils.vala"
	gala_utils_cache_clear_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ___lambda5__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 70 "../lib/Utils.vala"
	block1_data_unref (_data1_);
#line 70 "../lib/Utils.vala"
	_data1_ = NULL;
#line 559 "Utils.c"
}


/**
 * Returns a pixbuf for the application of this window or a default icon
 *
 * @param window       The window to get an icon for
 * @param size         The size of the icon
 * @param scale        The desired scale of the icon
 * @param ignore_cache Should not be necessary in most cases, if you care about the icon
 *                     being loaded correctly, you should consider using the WindowIcon class
 */
GdkPixbuf*
gala_utils_get_icon_for_window (MetaWindow* window,
                                gint size,
                                gint scale,
                                gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
#line 94 "../lib/Utils.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 96 "../lib/Utils.vala"
	_tmp0_ = gala_utils_get_icon_for_xid ((guint32) meta_window_get_xwindow (window), size, scale, ignore_cache);
#line 96 "../lib/Utils.vala"
	result = _tmp0_;
#line 96 "../lib/Utils.vala"
	return result;
#line 588 "Utils.c"
}


/**
 * Returns a pixbuf for a given xid or a default icon
 *
 * @see get_icon_for_window
 */
GdkPixbuf*
gala_utils_get_icon_for_xid (guint32 xid,
                             gint size,
                             gint scale,
                             gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _result_ = NULL;
	gchar* xid_key = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp7_;
	BamfMatcher* _tmp8_;
	BamfApplication* _tmp9_;
	BamfApplication* _tmp10_;
	BamfApplication* _tmp11_;
	BamfApplication* _tmp12_;
	GdkPixbuf* _tmp13_;
	GHashTable* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
#line 106 "../lib/Utils.vala"
	_result_ = NULL;
#line 107 "../lib/Utils.vala"
	_tmp0_ = g_strdup_printf ("%u::%i", (guint) xid, size);
#line 107 "../lib/Utils.vala"
	xid_key = _tmp0_;
#line 109 "../lib/Utils.vala"
	if (!ignore_cache) {
#line 629 "Utils.c"
		GHashTable* _tmp2_;
		const gchar* _tmp3_;
		gconstpointer _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 109 "../lib/Utils.vala"
		_tmp2_ = gala_utils_xid_pixbuf_cache;
#line 109 "../lib/Utils.vala"
		_tmp3_ = xid_key;
#line 109 "../lib/Utils.vala"
		_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 109 "../lib/Utils.vala"
		_tmp5_ = _g_object_ref0 ((GdkPixbuf*) _tmp4_);
#line 109 "../lib/Utils.vala"
		_g_object_unref0 (_result_);
#line 109 "../lib/Utils.vala"
		_result_ = _tmp5_;
#line 109 "../lib/Utils.vala"
		_tmp6_ = _result_;
#line 109 "../lib/Utils.vala"
		_tmp1_ = _tmp6_ != NULL;
#line 651 "Utils.c"
	} else {
#line 109 "../lib/Utils.vala"
		_tmp1_ = FALSE;
#line 655 "Utils.c"
	}
#line 109 "../lib/Utils.vala"
	if (_tmp1_) {
#line 110 "../lib/Utils.vala"
		result = _result_;
#line 110 "../lib/Utils.vala"
		_g_free0 (xid_key);
#line 110 "../lib/Utils.vala"
		return result;
#line 665 "Utils.c"
	}
#line 112 "../lib/Utils.vala"
	_tmp7_ = bamf_matcher_get_default ();
#line 112 "../lib/Utils.vala"
	_tmp8_ = _tmp7_;
#line 112 "../lib/Utils.vala"
	_tmp9_ = bamf_matcher_get_application_for_xid (_tmp8_, xid);
#line 112 "../lib/Utils.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 112 "../lib/Utils.vala"
	_tmp11_ = _tmp10_;
#line 112 "../lib/Utils.vala"
	_g_object_unref0 (_tmp8_);
#line 112 "../lib/Utils.vala"
	app = _tmp11_;
#line 113 "../lib/Utils.vala"
	_tmp12_ = app;
#line 113 "../lib/Utils.vala"
	_tmp13_ = gala_utils_get_icon_for_application (_tmp12_, size, scale, ignore_cache);
#line 113 "../lib/Utils.vala"
	_g_object_unref0 (_result_);
#line 113 "../lib/Utils.vala"
	_result_ = _tmp13_;
#line 115 "../lib/Utils.vala"
	_tmp14_ = gala_utils_xid_pixbuf_cache;
#line 115 "../lib/Utils.vala"
	_tmp15_ = xid_key;
#line 115 "../lib/Utils.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 115 "../lib/Utils.vala"
	_tmp17_ = _result_;
#line 115 "../lib/Utils.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 115 "../lib/Utils.vala"
	g_hash_table_insert (_tmp14_, _tmp16_, _tmp18_);
#line 117 "../lib/Utils.vala"
	result = _result_;
#line 117 "../lib/Utils.vala"
	_g_object_unref0 (app);
#line 117 "../lib/Utils.vala"
	_g_free0 (xid_key);
#line 117 "../lib/Utils.vala"
	return result;
#line 709 "Utils.c"
}


/**
 * Returns a pixbuf for this application or a default icon
 *
 * @see get_icon_for_window
 */
static GdkPixbuf*
gala_utils_get_icon_for_application (BamfApplication* app,
                                     gint size,
                                     gint scale,
                                     gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* image = NULL;
	gboolean not_cached = FALSE;
	gchar* icon = NULL;
	gchar* icon_key = NULL;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* _tmp41_;
	gboolean _tmp51_ = FALSE;
	GdkPixbuf* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gboolean _tmp60_;
	GError * _inner_error_ = NULL;
#line 128 "../lib/Utils.vala"
	image = NULL;
#line 129 "../lib/Utils.vala"
	not_cached = FALSE;
#line 131 "../lib/Utils.vala"
	icon = NULL;
#line 132 "../lib/Utils.vala"
	icon_key = NULL;
#line 134 "../lib/Utils.vala"
	if (app != NULL) {
#line 748 "Utils.c"
		const gchar* _tmp1_;
#line 134 "../lib/Utils.vala"
		_tmp1_ = bamf_application_get_desktop_file (app);
#line 134 "../lib/Utils.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 754 "Utils.c"
	} else {
#line 134 "../lib/Utils.vala"
		_tmp0_ = FALSE;
#line 758 "Utils.c"
	}
#line 134 "../lib/Utils.vala"
	if (_tmp0_) {
#line 762 "Utils.c"
		GDesktopAppInfo* appinfo = NULL;
		const gchar* _tmp2_;
		GDesktopAppInfo* _tmp3_;
		GDesktopAppInfo* _tmp4_;
#line 135 "../lib/Utils.vala"
		_tmp2_ = bamf_application_get_desktop_file (app);
#line 135 "../lib/Utils.vala"
		_tmp3_ = g_desktop_app_info_new_from_filename (_tmp2_);
#line 135 "../lib/Utils.vala"
		appinfo = _tmp3_;
#line 136 "../lib/Utils.vala"
		_tmp4_ = appinfo;
#line 136 "../lib/Utils.vala"
		if (_tmp4_ != NULL) {
#line 777 "Utils.c"
			GDesktopAppInfo* _tmp5_;
			GIcon* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gboolean _tmp10_ = FALSE;
#line 137 "../lib/Utils.vala"
			_tmp5_ = appinfo;
#line 137 "../lib/Utils.vala"
			_tmp6_ = g_app_info_get_icon ((GAppInfo*) _tmp5_);
#line 137 "../lib/Utils.vala"
			_tmp7_ = plank_drawing_service_get_icon_from_gicon (_tmp6_);
#line 137 "../lib/Utils.vala"
			_g_free0 (icon);
#line 137 "../lib/Utils.vala"
			icon = _tmp7_;
#line 138 "../lib/Utils.vala"
			_tmp8_ = icon;
#line 138 "../lib/Utils.vala"
			_tmp9_ = g_strdup_printf ("%s::%i::%i", _tmp8_, size, scale);
#line 138 "../lib/Utils.vala"
			_g_free0 (icon_key);
#line 138 "../lib/Utils.vala"
			icon_key = _tmp9_;
#line 139 "../lib/Utils.vala"
			if (ignore_cache) {
#line 139 "../lib/Utils.vala"
				_tmp10_ = TRUE;
#line 806 "Utils.c"
			} else {
				GHashTable* _tmp11_;
				const gchar* _tmp12_;
				gconstpointer _tmp13_;
				GdkPixbuf* _tmp14_;
				GdkPixbuf* _tmp15_;
#line 139 "../lib/Utils.vala"
				_tmp11_ = gala_utils_icon_pixbuf_cache;
#line 139 "../lib/Utils.vala"
				_tmp12_ = icon_key;
#line 139 "../lib/Utils.vala"
				_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
#line 139 "../lib/Utils.vala"
				_tmp14_ = _g_object_ref0 ((GdkPixbuf*) _tmp13_);
#line 139 "../lib/Utils.vala"
				_g_object_unref0 (image);
#line 139 "../lib/Utils.vala"
				image = _tmp14_;
#line 139 "../lib/Utils.vala"
				_tmp15_ = image;
#line 139 "../lib/Utils.vala"
				_tmp10_ = _tmp15_ == NULL;
#line 829 "Utils.c"
			}
#line 139 "../lib/Utils.vala"
			if (_tmp10_) {
#line 833 "Utils.c"
				gint scaled_size = 0;
				cairo_surface_t* surface = NULL;
				const gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				cairo_surface_t* _tmp19_;
				cairo_surface_t* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				GdkPixbuf* _tmp23_;
#line 140 "../lib/Utils.vala"
				scaled_size = size * scale;
#line 141 "../lib/Utils.vala"
				_tmp16_ = icon;
#line 141 "../lib/Utils.vala"
				_tmp17_ = scaled_size;
#line 141 "../lib/Utils.vala"
				_tmp18_ = scaled_size;
#line 141 "../lib/Utils.vala"
				_tmp19_ = plank_drawing_service_load_icon_for_scale (_tmp16_, _tmp17_, _tmp18_, scale);
#line 141 "../lib/Utils.vala"
				surface = _tmp19_;
#line 142 "../lib/Utils.vala"
				_tmp20_ = surface;
#line 142 "../lib/Utils.vala"
				_tmp21_ = scaled_size;
#line 142 "../lib/Utils.vala"
				_tmp22_ = scaled_size;
#line 142 "../lib/Utils.vala"
				_tmp23_ = gdk_pixbuf_get_from_surface (_tmp20_, 0, 0, _tmp21_, _tmp22_);
#line 142 "../lib/Utils.vala"
				_g_object_unref0 (image);
#line 142 "../lib/Utils.vala"
				image = _tmp23_;
#line 143 "../lib/Utils.vala"
				not_cached = TRUE;
#line 139 "../lib/Utils.vala"
				_cairo_surface_destroy0 (surface);
#line 872 "Utils.c"
			}
		}
#line 134 "../lib/Utils.vala"
		_g_object_unref0 (appinfo);
#line 877 "Utils.c"
	}
#line 148 "../lib/Utils.vala"
	_tmp24_ = image;
#line 148 "../lib/Utils.vala"
	if (_tmp24_ == NULL) {
#line 883 "Utils.c"
		{
			GtkIconTheme* icon_theme = NULL;
			GtkIconTheme* _tmp25_;
			gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			GHashTable* _tmp29_;
			const gchar* _tmp30_;
			gconstpointer _tmp31_;
			GdkPixbuf* _tmp32_;
			GdkPixbuf* _tmp33_;
#line 150 "../lib/Utils.vala"
			_tmp25_ = gtk_icon_theme_get_default ();
#line 150 "../lib/Utils.vala"
			icon_theme = _tmp25_;
#line 151 "../lib/Utils.vala"
			_tmp26_ = g_strdup ("application-default-icon");
#line 151 "../lib/Utils.vala"
			_g_free0 (icon);
#line 151 "../lib/Utils.vala"
			icon = _tmp26_;
#line 152 "../lib/Utils.vala"
			_tmp27_ = icon;
#line 152 "../lib/Utils.vala"
			_tmp28_ = g_strdup_printf ("%s::%i::%i", _tmp27_, size, scale);
#line 152 "../lib/Utils.vala"
			_g_free0 (icon_key);
#line 152 "../lib/Utils.vala"
			icon_key = _tmp28_;
#line 153 "../lib/Utils.vala"
			_tmp29_ = gala_utils_icon_pixbuf_cache;
#line 153 "../lib/Utils.vala"
			_tmp30_ = icon_key;
#line 153 "../lib/Utils.vala"
			_tmp31_ = g_hash_table_lookup (_tmp29_, _tmp30_);
#line 153 "../lib/Utils.vala"
			_tmp32_ = _g_object_ref0 ((GdkPixbuf*) _tmp31_);
#line 153 "../lib/Utils.vala"
			_g_object_unref0 (image);
#line 153 "../lib/Utils.vala"
			image = _tmp32_;
#line 153 "../lib/Utils.vala"
			_tmp33_ = image;
#line 153 "../lib/Utils.vala"
			if (_tmp33_ == NULL) {
#line 929 "Utils.c"
				GdkPixbuf* _tmp34_ = NULL;
				GtkIconTheme* _tmp35_;
				const gchar* _tmp36_;
				GdkPixbuf* _tmp37_;
				GdkPixbuf* _tmp38_;
#line 154 "../lib/Utils.vala"
				_tmp35_ = icon_theme;
#line 154 "../lib/Utils.vala"
				_tmp36_ = icon;
#line 154 "../lib/Utils.vala"
				_tmp37_ = gtk_icon_theme_load_icon_for_scale (_tmp35_, _tmp36_, size, scale, 0, &_inner_error_);
#line 154 "../lib/Utils.vala"
				_tmp34_ = _tmp37_;
#line 154 "../lib/Utils.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 945 "Utils.c"
					goto __catch0_g_error;
				}
#line 154 "../lib/Utils.vala"
				_tmp38_ = _tmp34_;
#line 154 "../lib/Utils.vala"
				_tmp34_ = NULL;
#line 154 "../lib/Utils.vala"
				_g_object_unref0 (image);
#line 154 "../lib/Utils.vala"
				image = _tmp38_;
#line 155 "../lib/Utils.vala"
				not_cached = TRUE;
#line 153 "../lib/Utils.vala"
				_g_object_unref0 (_tmp34_);
#line 960 "Utils.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp39_;
			const gchar* _tmp40_;
#line 149 "../lib/Utils.vala"
			e = _inner_error_;
#line 149 "../lib/Utils.vala"
			_inner_error_ = NULL;
#line 158 "../lib/Utils.vala"
			_tmp39_ = e;
#line 158 "../lib/Utils.vala"
			_tmp40_ = _tmp39_->message;
#line 158 "../lib/Utils.vala"
			g_warning ("Utils.vala:158: %s", _tmp40_);
#line 149 "../lib/Utils.vala"
			_g_error_free0 (e);
#line 981 "Utils.c"
		}
		__finally0:
#line 149 "../lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 149 "../lib/Utils.vala"
			_g_free0 (icon_key);
#line 149 "../lib/Utils.vala"
			_g_free0 (icon);
#line 149 "../lib/Utils.vala"
			_g_object_unref0 (image);
#line 149 "../lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 149 "../lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 149 "../lib/Utils.vala"
			return NULL;
#line 998 "Utils.c"
		}
	}
#line 162 "../lib/Utils.vala"
	_tmp41_ = image;
#line 162 "../lib/Utils.vala"
	if (_tmp41_ == NULL) {
#line 1005 "Utils.c"
		gchar* _tmp42_;
		gchar* _tmp43_;
		GHashTable* _tmp44_;
		const gchar* _tmp45_;
		gconstpointer _tmp46_;
		GdkPixbuf* _tmp47_;
		GdkPixbuf* _tmp48_;
#line 163 "../lib/Utils.vala"
		_tmp42_ = g_strdup ("");
#line 163 "../lib/Utils.vala"
		_g_free0 (icon);
#line 163 "../lib/Utils.vala"
		icon = _tmp42_;
#line 164 "../lib/Utils.vala"
		_tmp43_ = g_strdup_printf ("::%i", size);
#line 164 "../lib/Utils.vala"
		_g_free0 (icon_key);
#line 164 "../lib/Utils.vala"
		icon_key = _tmp43_;
#line 165 "../lib/Utils.vala"
		_tmp44_ = gala_utils_icon_pixbuf_cache;
#line 165 "../lib/Utils.vala"
		_tmp45_ = icon_key;
#line 165 "../lib/Utils.vala"
		_tmp46_ = g_hash_table_lookup (_tmp44_, _tmp45_);
#line 165 "../lib/Utils.vala"
		_tmp47_ = _g_object_ref0 ((GdkPixbuf*) _tmp46_);
#line 165 "../lib/Utils.vala"
		_g_object_unref0 (image);
#line 165 "../lib/Utils.vala"
		image = _tmp47_;
#line 165 "../lib/Utils.vala"
		_tmp48_ = image;
#line 165 "../lib/Utils.vala"
		if (_tmp48_ == NULL) {
#line 1041 "Utils.c"
			GdkPixbuf* _tmp49_;
			GdkPixbuf* _tmp50_;
#line 166 "../lib/Utils.vala"
			_tmp49_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, size, size);
#line 166 "../lib/Utils.vala"
			_g_object_unref0 (image);
#line 166 "../lib/Utils.vala"
			image = _tmp49_;
#line 167 "../lib/Utils.vala"
			_tmp50_ = image;
#line 167 "../lib/Utils.vala"
			gdk_pixbuf_fill (_tmp50_, (guint32) 0x00000000);
#line 168 "../lib/Utils.vala"
			not_cached = TRUE;
#line 1056 "Utils.c"
		}
	}
#line 172 "../lib/Utils.vala"
	_tmp52_ = image;
#line 172 "../lib/Utils.vala"
	_tmp53_ = gdk_pixbuf_get_width (_tmp52_);
#line 172 "../lib/Utils.vala"
	_tmp54_ = _tmp53_;
#line 172 "../lib/Utils.vala"
	if ((size * scale) != _tmp54_) {
#line 172 "../lib/Utils.vala"
		_tmp51_ = TRUE;
#line 1069 "Utils.c"
	} else {
		GdkPixbuf* _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
#line 172 "../lib/Utils.vala"
		_tmp55_ = image;
#line 172 "../lib/Utils.vala"
		_tmp56_ = gdk_pixbuf_get_height (_tmp55_);
#line 172 "../lib/Utils.vala"
		_tmp57_ = _tmp56_;
#line 172 "../lib/Utils.vala"
		_tmp51_ = (size * scale) != _tmp57_;
#line 1082 "Utils.c"
	}
#line 172 "../lib/Utils.vala"
	if (_tmp51_) {
#line 1086 "Utils.c"
		GdkPixbuf* _tmp58_;
		GdkPixbuf* _tmp59_;
#line 173 "../lib/Utils.vala"
		_tmp58_ = image;
#line 173 "../lib/Utils.vala"
		_tmp59_ = plank_drawing_service_ar_scale (_tmp58_, size * scale, size * scale);
#line 173 "../lib/Utils.vala"
		_g_object_unref0 (image);
#line 173 "../lib/Utils.vala"
		image = _tmp59_;
#line 1097 "Utils.c"
	}
#line 175 "../lib/Utils.vala"
	_tmp60_ = not_cached;
#line 175 "../lib/Utils.vala"
	if (_tmp60_) {
#line 1103 "Utils.c"
		GHashTable* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		GdkPixbuf* _tmp64_;
		GdkPixbuf* _tmp65_;
#line 176 "../lib/Utils.vala"
		_tmp61_ = gala_utils_icon_pixbuf_cache;
#line 176 "../lib/Utils.vala"
		_tmp62_ = icon_key;
#line 176 "../lib/Utils.vala"
		_tmp63_ = g_strdup (_tmp62_);
#line 176 "../lib/Utils.vala"
		_tmp64_ = image;
#line 176 "../lib/Utils.vala"
		_tmp65_ = _g_object_ref0 (_tmp64_);
#line 176 "../lib/Utils.vala"
		g_hash_table_insert (_tmp61_, _tmp63_, _tmp65_);
#line 1121 "Utils.c"
	}
#line 178 "../lib/Utils.vala"
	result = image;
#line 178 "../lib/Utils.vala"
	_g_free0 (icon_key);
#line 178 "../lib/Utils.vala"
	_g_free0 (icon);
#line 178 "../lib/Utils.vala"
	return result;
#line 1131 "Utils.c"
}


/**
 * Get the next window that should be active on a workspace right now. Based on
 * stacking order
 *
 * @param workspace The workspace on which to find the window
 * @param backward  Whether to get the previous one instead
 */
MetaWindow*
gala_utils_get_next_window (MetaWorkspace* workspace,
                            gboolean backward)
{
	MetaWindow* result = NULL;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaWindow* window = NULL;
	MetaDisplay* _tmp5_;
	MetaWindow* _tmp6_;
	MetaWindow* _tmp7_;
	MetaWindow* _tmp8_;
#line 188 "../lib/Utils.vala"
	g_return_val_if_fail (workspace != NULL, NULL);
#line 190 "../lib/Utils.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 190 "../lib/Utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 190 "../lib/Utils.vala"
	screen = _tmp1_;
#line 191 "../lib/Utils.vala"
	_tmp2_ = screen;
#line 191 "../lib/Utils.vala"
	_tmp3_ = meta_screen_get_display (_tmp2_);
#line 191 "../lib/Utils.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 191 "../lib/Utils.vala"
	display = _tmp4_;
#line 193 "../lib/Utils.vala"
	_tmp5_ = display;
#line 193 "../lib/Utils.vala"
	_tmp6_ = meta_display_get_tab_next (_tmp5_, META_TAB_LIST_NORMAL, workspace, NULL, backward);
#line 193 "../lib/Utils.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 193 "../lib/Utils.vala"
	window = _tmp7_;
#line 196 "../lib/Utils.vala"
	_tmp8_ = window;
#line 196 "../lib/Utils.vala"
	if (_tmp8_ == NULL) {
#line 1187 "Utils.c"
		MetaDisplay* _tmp9_;
		MetaWindow* _tmp10_;
		MetaWindow* _tmp11_;
#line 197 "../lib/Utils.vala"
		_tmp9_ = display;
#line 197 "../lib/Utils.vala"
		_tmp10_ = meta_display_get_tab_current (_tmp9_, META_TAB_LIST_NORMAL, workspace);
#line 197 "../lib/Utils.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 197 "../lib/Utils.vala"
		_g_object_unref0 (window);
#line 197 "../lib/Utils.vala"
		window = _tmp11_;
#line 1201 "Utils.c"
	}
#line 199 "../lib/Utils.vala"
	result = window;
#line 199 "../lib/Utils.vala"
	_g_object_unref0 (display);
#line 199 "../lib/Utils.vala"
	_g_object_unref0 (screen);
#line 199 "../lib/Utils.vala"
	return result;
#line 1211 "Utils.c"
}


/**
 * Get the number of toplevel windows on a workspace excluding those that are
 * on all workspaces
 *
 * @param workspace The workspace on which to count the windows
 */
guint
gala_utils_get_n_windows (MetaWorkspace* workspace)
{
	guint result = 0U;
	gint n = 0;
	GList* _tmp0_;
#line 208 "../lib/Utils.vala"
	g_return_val_if_fail (workspace != NULL, 0U);
#line 210 "../lib/Utils.vala"
	n = 0;
#line 211 "../lib/Utils.vala"
	_tmp0_ = meta_workspace_list_windows (workspace);
#line 1233 "Utils.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 211 "../lib/Utils.vala"
		window_collection = _tmp0_;
#line 211 "../lib/Utils.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1241 "Utils.c"
			MetaWindow* window = NULL;
#line 211 "../lib/Utils.vala"
			window = (MetaWindow*) window_it->data;
#line 1245 "Utils.c"
			{
				MetaWindow* _tmp1_;
				gboolean _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				MetaWindow* _tmp6_;
				MetaWindowType _tmp7_;
				MetaWindowType _tmp8_;
#line 212 "../lib/Utils.vala"
				_tmp1_ = window;
#line 212 "../lib/Utils.vala"
				g_object_get (_tmp1_, "on-all-workspaces", &_tmp2_, NULL);
#line 212 "../lib/Utils.vala"
				_tmp3_ = _tmp2_;
#line 212 "../lib/Utils.vala"
				if (_tmp3_) {
#line 213 "../lib/Utils.vala"
					continue;
#line 1265 "Utils.c"
				}
#line 214 "../lib/Utils.vala"
				_tmp6_ = window;
#line 214 "../lib/Utils.vala"
				_tmp7_ = meta_window_get_window_type (_tmp6_);
#line 214 "../lib/Utils.vala"
				_tmp8_ = _tmp7_;
#line 214 "../lib/Utils.vala"
				if (_tmp8_ == META_WINDOW_NORMAL) {
#line 214 "../lib/Utils.vala"
					_tmp5_ = TRUE;
#line 1277 "Utils.c"
				} else {
					MetaWindow* _tmp9_;
					MetaWindowType _tmp10_;
					MetaWindowType _tmp11_;
#line 215 "../lib/Utils.vala"
					_tmp9_ = window;
#line 215 "../lib/Utils.vala"
					_tmp10_ = meta_window_get_window_type (_tmp9_);
#line 215 "../lib/Utils.vala"
					_tmp11_ = _tmp10_;
#line 215 "../lib/Utils.vala"
					_tmp5_ = _tmp11_ == META_WINDOW_DIALOG;
#line 1290 "Utils.c"
				}
#line 214 "../lib/Utils.vala"
				if (_tmp5_) {
#line 214 "../lib/Utils.vala"
					_tmp4_ = TRUE;
#line 1296 "Utils.c"
				} else {
					MetaWindow* _tmp12_;
					MetaWindowType _tmp13_;
					MetaWindowType _tmp14_;
#line 216 "../lib/Utils.vala"
					_tmp12_ = window;
#line 216 "../lib/Utils.vala"
					_tmp13_ = meta_window_get_window_type (_tmp12_);
#line 216 "../lib/Utils.vala"
					_tmp14_ = _tmp13_;
#line 216 "../lib/Utils.vala"
					_tmp4_ = _tmp14_ == META_WINDOW_MODAL_DIALOG;
#line 1309 "Utils.c"
				}
#line 214 "../lib/Utils.vala"
				if (_tmp4_) {
#line 1313 "Utils.c"
					gint _tmp15_;
#line 217 "../lib/Utils.vala"
					_tmp15_ = n;
#line 217 "../lib/Utils.vala"
					n = _tmp15_ + 1;
#line 1319 "Utils.c"
				}
			}
		}
#line 211 "../lib/Utils.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1325 "Utils.c"
	}
#line 220 "../lib/Utils.vala"
	result = (guint) n;
#line 220 "../lib/Utils.vala"
	return result;
#line 1331 "Utils.c"
}


/**
 * Creates an actor showing the current contents of the given WindowActor.
 *
 * @param actor      The actor from which to create a shnapshot
 * @param inner_rect The inner (actually visible) rectangle of the window
 * @param outer_rect The outer (input region) rectangle of the window
 *
 * @return           A copy of the actor at that time or %NULL
 */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 232 "../lib/Utils.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 232 "../lib/Utils.vala"
	return _data2_;
#line 1351 "Utils.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 232 "../lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 232 "../lib/Utils.vala"
		_cairo_surface_destroy0 (_data2_->surface);
#line 232 "../lib/Utils.vala"
		g_slice_free (Block2Data, _data2_);
#line 1366 "Utils.c"
	}
}


static gboolean
__lambda7_ (Block2Data* _data2_,
            cairo_t* cr)
{
	gboolean result = FALSE;
	cairo_surface_t* _tmp0_;
#line 250 "../lib/Utils.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 251 "../lib/Utils.vala"
	_tmp0_ = _data2_->surface;
#line 251 "../lib/Utils.vala"
	cairo_set_source_surface (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
#line 252 "../lib/Utils.vala"
	cairo_paint (cr);
#line 253 "../lib/Utils.vala"
	result = FALSE;
#line 253 "../lib/Utils.vala"
	return result;
#line 1389 "Utils.c"
}


static gboolean
___lambda7__clutter_canvas_draw (ClutterCanvas* _sender,
                                 cairo_t* cr,
                                 gint width,
                                 gint height,
                                 gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, cr);
#line 250 "../lib/Utils.vala"
	return result;
#line 1404 "Utils.c"
}


ClutterActor*
gala_utils_get_window_actor_snapshot (MetaWindowActor* actor,
                                      MetaRectangle* inner_rect,
                                      MetaRectangle* outer_rect)
{
	ClutterActor* result = NULL;
	Block2Data* _data2_;
	MetaShapedTexture* texture = NULL;
	ClutterActor* _tmp0_;
	MetaShapedTexture* _tmp1_;
	MetaShapedTexture* _tmp2_;
	MetaShapedTexture* _tmp3_;
	MetaRectangle _tmp4_;
	gint _tmp5_;
	MetaRectangle _tmp6_;
	gint _tmp7_;
	MetaRectangle _tmp8_;
	gint _tmp9_;
	MetaRectangle _tmp10_;
	gint _tmp11_;
	MetaRectangle _tmp12_;
	gint _tmp13_;
	MetaRectangle _tmp14_;
	gint _tmp15_;
	cairo_rectangle_int_t _tmp16_ = {0};
	cairo_surface_t* _tmp17_;
	cairo_surface_t* _tmp18_;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp19_;
	gulong handler = 0UL;
	ClutterCanvas* _tmp20_;
	gulong _tmp21_;
	ClutterCanvas* _tmp22_;
	MetaRectangle _tmp23_;
	gint _tmp24_;
	MetaRectangle _tmp25_;
	gint _tmp26_;
	ClutterCanvas* _tmp27_;
	gulong _tmp28_;
	ClutterActor* container = NULL;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	MetaRectangle _tmp31_;
	gint _tmp32_;
	MetaRectangle _tmp33_;
	gint _tmp34_;
	ClutterActor* _tmp35_;
	ClutterCanvas* _tmp36_;
#line 232 "../lib/Utils.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 232 "../lib/Utils.vala"
	g_return_val_if_fail (inner_rect != NULL, NULL);
#line 232 "../lib/Utils.vala"
	g_return_val_if_fail (outer_rect != NULL, NULL);
#line 232 "../lib/Utils.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 232 "../lib/Utils.vala"
	_data2_->_ref_count_ = 1;
#line 234 "../lib/Utils.vala"
	_tmp0_ = meta_window_actor_get_texture (actor);
#line 234 "../lib/Utils.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, meta_shaped_texture_get_type ()) ? ((MetaShapedTexture*) _tmp0_) : NULL);
#line 234 "../lib/Utils.vala"
	texture = _tmp1_;
#line 236 "../lib/Utils.vala"
	_tmp2_ = texture;
#line 236 "../lib/Utils.vala"
	if (_tmp2_ == NULL) {
#line 237 "../lib/Utils.vala"
		result = NULL;
#line 237 "../lib/Utils.vala"
		_g_object_unref0 (texture);
#line 237 "../lib/Utils.vala"
		block2_data_unref (_data2_);
#line 237 "../lib/Utils.vala"
		_data2_ = NULL;
#line 237 "../lib/Utils.vala"
		return result;
#line 1486 "Utils.c"
	}
#line 239 "../lib/Utils.vala"
	_tmp3_ = texture;
#line 239 "../lib/Utils.vala"
	_tmp4_ = *inner_rect;
#line 239 "../lib/Utils.vala"
	_tmp5_ = _tmp4_.x;
#line 239 "../lib/Utils.vala"
	_tmp6_ = *outer_rect;
#line 239 "../lib/Utils.vala"
	_tmp7_ = _tmp6_.x;
#line 239 "../lib/Utils.vala"
	_tmp8_ = *inner_rect;
#line 239 "../lib/Utils.vala"
	_tmp9_ = _tmp8_.y;
#line 239 "../lib/Utils.vala"
	_tmp10_ = *outer_rect;
#line 239 "../lib/Utils.vala"
	_tmp11_ = _tmp10_.y;
#line 239 "../lib/Utils.vala"
	_tmp12_ = *inner_rect;
#line 239 "../lib/Utils.vala"
	_tmp13_ = _tmp12_.width;
#line 239 "../lib/Utils.vala"
	_tmp14_ = *inner_rect;
#line 239 "../lib/Utils.vala"
	_tmp15_ = _tmp14_.height;
#line 239 "../lib/Utils.vala"
	_tmp16_.x = _tmp5_ - _tmp7_;
#line 239 "../lib/Utils.vala"
	_tmp16_.y = _tmp9_ - _tmp11_;
#line 239 "../lib/Utils.vala"
	_tmp16_.width = _tmp13_;
#line 239 "../lib/Utils.vala"
	_tmp16_.height = _tmp15_;
#line 239 "../lib/Utils.vala"
	_tmp17_ = meta_shaped_texture_get_image (_tmp3_, &_tmp16_);
#line 239 "../lib/Utils.vala"
	_data2_->surface = _tmp17_;
#line 246 "../lib/Utils.vala"
	_tmp18_ = _data2_->surface;
#line 246 "../lib/Utils.vala"
	if (_tmp18_ == NULL) {
#line 247 "../lib/Utils.vala"
		result = NULL;
#line 247 "../lib/Utils.vala"
		_g_object_unref0 (texture);
#line 247 "../lib/Utils.vala"
		block2_data_unref (_data2_);
#line 247 "../lib/Utils.vala"
		_data2_ = NULL;
#line 247 "../lib/Utils.vala"
		return result;
#line 1540 "Utils.c"
	}
#line 249 "../lib/Utils.vala"
	_tmp19_ = (ClutterCanvas*) clutter_canvas_new ();
#line 249 "../lib/Utils.vala"
	canvas = _tmp19_;
#line 250 "../lib/Utils.vala"
	_tmp20_ = canvas;
#line 250 "../lib/Utils.vala"
	_tmp21_ = g_signal_connect_data (_tmp20_, "draw", (GCallback) ___lambda7__clutter_canvas_draw, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 250 "../lib/Utils.vala"
	handler = _tmp21_;
#line 255 "../lib/Utils.vala"
	_tmp22_ = canvas;
#line 255 "../lib/Utils.vala"
	_tmp23_ = *inner_rect;
#line 255 "../lib/Utils.vala"
	_tmp24_ = _tmp23_.width;
#line 255 "../lib/Utils.vala"
	_tmp25_ = *inner_rect;
#line 255 "../lib/Utils.vala"
	_tmp26_ = _tmp25_.height;
#line 255 "../lib/Utils.vala"
	clutter_canvas_set_size (_tmp22_, _tmp24_, _tmp26_);
#line 256 "../lib/Utils.vala"
	_tmp27_ = canvas;
#line 256 "../lib/Utils.vala"
	_tmp28_ = handler;
#line 256 "../lib/Utils.vala"
	g_signal_handler_disconnect (_tmp27_, _tmp28_);
#line 258 "../lib/Utils.vala"
	_tmp29_ = clutter_actor_new ();
#line 258 "../lib/Utils.vala"
	g_object_ref_sink (_tmp29_);
#line 258 "../lib/Utils.vala"
	container = _tmp29_;
#line 259 "../lib/Utils.vala"
	_tmp30_ = container;
#line 259 "../lib/Utils.vala"
	_tmp31_ = *inner_rect;
#line 259 "../lib/Utils.vala"
	_tmp32_ = _tmp31_.width;
#line 259 "../lib/Utils.vala"
	_tmp33_ = *inner_rect;
#line 259 "../lib/Utils.vala"
	_tmp34_ = _tmp33_.height;
#line 259 "../lib/Utils.vala"
	clutter_actor_set_size (_tmp30_, (gfloat) _tmp32_, (gfloat) _tmp34_);
#line 260 "../lib/Utils.vala"
	_tmp35_ = container;
#line 260 "../lib/Utils.vala"
	_tmp36_ = canvas;
#line 260 "../lib/Utils.vala"
	clutter_actor_set_content (_tmp35_, (ClutterContent*) _tmp36_);
#line 262 "../lib/Utils.vala"
	result = container;
#line 262 "../lib/Utils.vala"
	_g_object_unref0 (canvas);
#line 262 "../lib/Utils.vala"
	_g_object_unref0 (texture);
#line 262 "../lib/Utils.vala"
	block2_data_unref (_data2_);
#line 262 "../lib/Utils.vala"
	_data2_ = NULL;
#line 262 "../lib/Utils.vala"
	return result;
#line 1606 "Utils.c"
}


/**
 * Ring the system bell, will most likely emit a <beep> error sound or, if the
 * audible bell is disabled, flash the screen
 *
 * @param screen The screen to flash, if necessary
 */
void
gala_utils_bell (MetaScreen* screen)
{
#line 271 "../lib/Utils.vala"
	g_return_if_fail (screen != NULL);
#line 273 "../lib/Utils.vala"
	if (meta_prefs_bell_is_audible ()) {
#line 274 "../lib/Utils.vala"
		gdk_beep ();
#line 1625 "Utils.c"
	} else {
		MetaDisplay* _tmp0_;
		MetaCompositor* _tmp1_;
#line 276 "../lib/Utils.vala"
		_tmp0_ = meta_screen_get_display (screen);
#line 276 "../lib/Utils.vala"
		_tmp1_ = meta_display_get_compositor (_tmp0_);
#line 276 "../lib/Utils.vala"
		meta_compositor_flash_screen (_tmp1_, screen);
#line 1635 "Utils.c"
	}
}


/**
 * Returns the pixbuf that is used for close buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf*
gala_utils_get_close_button_pixbuf (void)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GError * _inner_error_ = NULL;
#line 287 "../lib/Utils.vala"
	_tmp0_ = gala_utils_close_pixbuf;
#line 287 "../lib/Utils.vala"
	if (_tmp0_ == NULL) {
#line 1658 "Utils.c"
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
#line 289 "../lib/Utils.vala"
		_tmp1_ = meta_get_backend ();
#line 289 "../lib/Utils.vala"
		_tmp2_ = meta_backend_get_settings (_tmp1_);
#line 289 "../lib/Utils.vala"
		scale = meta_settings_get_ui_scaling_factor (_tmp2_);
#line 1668 "Utils.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			gint _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 294 "../lib/Utils.vala"
			_tmp4_ = scale;
#line 294 "../lib/Utils.vala"
			_tmp5_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/close.svg", -1, 36 * _tmp4_, TRUE, &_inner_error_);
#line 294 "../lib/Utils.vala"
			_tmp3_ = _tmp5_;
#line 294 "../lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1682 "Utils.c"
				goto __catch1_g_error;
			}
#line 294 "../lib/Utils.vala"
			_tmp6_ = _tmp3_;
#line 294 "../lib/Utils.vala"
			_tmp3_ = NULL;
#line 294 "../lib/Utils.vala"
			_g_object_unref0 (gala_utils_close_pixbuf);
#line 294 "../lib/Utils.vala"
			gala_utils_close_pixbuf = _tmp6_;
#line 293 "../lib/Utils.vala"
			_g_object_unref0 (_tmp3_);
#line 1695 "Utils.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 293 "../lib/Utils.vala"
			e = _inner_error_;
#line 293 "../lib/Utils.vala"
			_inner_error_ = NULL;
#line 296 "../lib/Utils.vala"
			_tmp7_ = e;
#line 296 "../lib/Utils.vala"
			_tmp8_ = _tmp7_->message;
#line 296 "../lib/Utils.vala"
			g_warning ("Utils.vala:296: %s", _tmp8_);
#line 297 "../lib/Utils.vala"
			result = NULL;
#line 297 "../lib/Utils.vala"
			_g_error_free0 (e);
#line 297 "../lib/Utils.vala"
			return result;
#line 1719 "Utils.c"
		}
		__finally1:
#line 293 "../lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 293 "../lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 293 "../lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 293 "../lib/Utils.vala"
			return NULL;
#line 1730 "Utils.c"
		}
	}
#line 301 "../lib/Utils.vala"
	_tmp9_ = gala_utils_close_pixbuf;
#line 301 "../lib/Utils.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 301 "../lib/Utils.vala"
	result = _tmp10_;
#line 301 "../lib/Utils.vala"
	return result;
#line 1741 "Utils.c"
}


/**
 * Creates a new reactive ClutterActor at 36px with the close pixbuf
 *
 * @return The close button actor
 */
ClutterActor*
gala_utils_create_close_button (void)
{
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 311 "../lib/Utils.vala"
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
#line 311 "../lib/Utils.vala"
	g_object_ref_sink (_tmp0_);
#line 311 "../lib/Utils.vala"
	texture = _tmp0_;
#line 312 "../lib/Utils.vala"
	_tmp1_ = gala_utils_get_close_button_pixbuf ();
#line 312 "../lib/Utils.vala"
	pixbuf = _tmp1_;
#line 314 "../lib/Utils.vala"
	_tmp2_ = texture;
#line 314 "../lib/Utils.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
#line 316 "../lib/Utils.vala"
	_tmp3_ = pixbuf;
#line 316 "../lib/Utils.vala"
	if (_tmp3_ != NULL) {
#line 1779 "Utils.c"
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			ClutterTexture* _tmp6_;
			GdkPixbuf* _tmp7_;
			guint8* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
#line 320 "../lib/Utils.vala"
			_tmp5_ = pixbuf;
#line 320 "../lib/Utils.vala"
			if (gdk_pixbuf_get_has_alpha (_tmp5_)) {
#line 320 "../lib/Utils.vala"
				_tmp4_ = 4;
#line 1796 "Utils.c"
			} else {
#line 320 "../lib/Utils.vala"
				_tmp4_ = 3;
#line 1800 "Utils.c"
			}
#line 318 "../lib/Utils.vala"
			_tmp6_ = texture;
#line 318 "../lib/Utils.vala"
			_tmp7_ = pixbuf;
#line 318 "../lib/Utils.vala"
			_tmp8_ = gdk_pixbuf_get_pixels (_tmp7_);
#line 318 "../lib/Utils.vala"
			_tmp9_ = pixbuf;
#line 318 "../lib/Utils.vala"
			_tmp10_ = pixbuf;
#line 318 "../lib/Utils.vala"
			_tmp11_ = pixbuf;
#line 318 "../lib/Utils.vala"
			_tmp12_ = pixbuf;
#line 318 "../lib/Utils.vala"
			clutter_texture_set_from_rgb_data (_tmp6_, _tmp8_, gdk_pixbuf_get_has_alpha (_tmp9_), gdk_pixbuf_get_width (_tmp10_), gdk_pixbuf_get_height (_tmp11_), gdk_pixbuf_get_rowstride (_tmp12_), _tmp4_, 0, &_inner_error_);
#line 318 "../lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1820 "Utils.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
#line 317 "../lib/Utils.vala"
			e = _inner_error_;
#line 317 "../lib/Utils.vala"
			_inner_error_ = NULL;
#line 317 "../lib/Utils.vala"
			_g_error_free0 (e);
#line 1834 "Utils.c"
		}
		__finally2:
#line 317 "../lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 317 "../lib/Utils.vala"
			_g_object_unref0 (pixbuf);
#line 317 "../lib/Utils.vala"
			_g_object_unref0 (texture);
#line 317 "../lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 317 "../lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 317 "../lib/Utils.vala"
			return NULL;
#line 1849 "Utils.c"
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp13_;
		MetaSettings* _tmp14_;
		ClutterTexture* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		ClutterTexture* _tmp18_;
		ClutterColor _tmp19_ = {0};
#line 327 "../lib/Utils.vala"
		_tmp13_ = meta_get_backend ();
#line 327 "../lib/Utils.vala"
		_tmp14_ = meta_backend_get_settings (_tmp13_);
#line 327 "../lib/Utils.vala"
		scale = meta_settings_get_ui_scaling_factor (_tmp14_);
#line 331 "../lib/Utils.vala"
		_tmp15_ = texture;
#line 331 "../lib/Utils.vala"
		_tmp16_ = scale;
#line 331 "../lib/Utils.vala"
		_tmp17_ = scale;
#line 331 "../lib/Utils.vala"
		clutter_actor_set_size ((ClutterActor*) _tmp15_, (gfloat) (36 * _tmp16_), (gfloat) (36 * _tmp17_));
#line 332 "../lib/Utils.vala"
		_tmp18_ = texture;
#line 332 "../lib/Utils.vala"
		_tmp19_.red = (guint8) 255;
#line 332 "../lib/Utils.vala"
		_tmp19_.green = (guint8) 0;
#line 332 "../lib/Utils.vala"
		_tmp19_.blue = (guint8) 0;
#line 332 "../lib/Utils.vala"
		_tmp19_.alpha = (guint8) 255;
#line 332 "../lib/Utils.vala"
		clutter_actor_set_background_color ((ClutterActor*) _tmp18_, &_tmp19_);
#line 1886 "Utils.c"
	}
#line 335 "../lib/Utils.vala"
	result = (ClutterActor*) texture;
#line 335 "../lib/Utils.vala"
	_g_object_unref0 (pixbuf);
#line 335 "../lib/Utils.vala"
	return result;
#line 1894 "Utils.c"
}


/**
 * Returns the pixbuf that is used for resize buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf*
gala_utils_get_resize_button_pixbuf (void)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GError * _inner_error_ = NULL;
#line 345 "../lib/Utils.vala"
	_tmp0_ = gala_utils_resize_pixbuf;
#line 345 "../lib/Utils.vala"
	if (_tmp0_ == NULL) {
#line 1916 "Utils.c"
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
#line 347 "../lib/Utils.vala"
		_tmp1_ = meta_get_backend ();
#line 347 "../lib/Utils.vala"
		_tmp2_ = meta_backend_get_settings (_tmp1_);
#line 347 "../lib/Utils.vala"
		scale = meta_settings_get_ui_scaling_factor (_tmp2_);
#line 1926 "Utils.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			gint _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 352 "../lib/Utils.vala"
			_tmp4_ = scale;
#line 352 "../lib/Utils.vala"
			_tmp5_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/resize.svg", -1, 36 * _tmp4_, TRUE, &_inner_error_);
#line 352 "../lib/Utils.vala"
			_tmp3_ = _tmp5_;
#line 352 "../lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1940 "Utils.c"
				goto __catch3_g_error;
			}
#line 352 "../lib/Utils.vala"
			_tmp6_ = _tmp3_;
#line 352 "../lib/Utils.vala"
			_tmp3_ = NULL;
#line 352 "../lib/Utils.vala"
			_g_object_unref0 (gala_utils_resize_pixbuf);
#line 352 "../lib/Utils.vala"
			gala_utils_resize_pixbuf = _tmp6_;
#line 351 "../lib/Utils.vala"
			_g_object_unref0 (_tmp3_);
#line 1953 "Utils.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 351 "../lib/Utils.vala"
			e = _inner_error_;
#line 351 "../lib/Utils.vala"
			_inner_error_ = NULL;
#line 354 "../lib/Utils.vala"
			_tmp7_ = e;
#line 354 "../lib/Utils.vala"
			_tmp8_ = _tmp7_->message;
#line 354 "../lib/Utils.vala"
			g_warning ("Utils.vala:354: %s", _tmp8_);
#line 355 "../lib/Utils.vala"
			result = NULL;
#line 355 "../lib/Utils.vala"
			_g_error_free0 (e);
#line 355 "../lib/Utils.vala"
			return result;
#line 1977 "Utils.c"
		}
		__finally3:
#line 351 "../lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 351 "../lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 351 "../lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 351 "../lib/Utils.vala"
			return NULL;
#line 1988 "Utils.c"
		}
	}
#line 359 "../lib/Utils.vala"
	_tmp9_ = gala_utils_resize_pixbuf;
#line 359 "../lib/Utils.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 359 "../lib/Utils.vala"
	result = _tmp10_;
#line 359 "../lib/Utils.vala"
	return result;
#line 1999 "Utils.c"
}


/**
 * Creates a new reactive ClutterActor at 36px with the resize pixbuf
 *
 * @return The resize button actor
 */
ClutterActor*
gala_utils_create_resize_button (void)
{
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 369 "../lib/Utils.vala"
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
#line 369 "../lib/Utils.vala"
	g_object_ref_sink (_tmp0_);
#line 369 "../lib/Utils.vala"
	texture = _tmp0_;
#line 370 "../lib/Utils.vala"
	_tmp1_ = gala_utils_get_resize_button_pixbuf ();
#line 370 "../lib/Utils.vala"
	pixbuf = _tmp1_;
#line 372 "../lib/Utils.vala"
	_tmp2_ = texture;
#line 372 "../lib/Utils.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
#line 374 "../lib/Utils.vala"
	_tmp3_ = pixbuf;
#line 374 "../lib/Utils.vala"
	if (_tmp3_ != NULL) {
#line 2037 "Utils.c"
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			ClutterTexture* _tmp6_;
			GdkPixbuf* _tmp7_;
			guint8* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
#line 378 "../lib/Utils.vala"
			_tmp5_ = pixbuf;
#line 378 "../lib/Utils.vala"
			if (gdk_pixbuf_get_has_alpha (_tmp5_)) {
#line 378 "../lib/Utils.vala"
				_tmp4_ = 4;
#line 2054 "Utils.c"
			} else {
#line 378 "../lib/Utils.vala"
				_tmp4_ = 3;
#line 2058 "Utils.c"
			}
#line 376 "../lib/Utils.vala"
			_tmp6_ = texture;
#line 376 "../lib/Utils.vala"
			_tmp7_ = pixbuf;
#line 376 "../lib/Utils.vala"
			_tmp8_ = gdk_pixbuf_get_pixels (_tmp7_);
#line 376 "../lib/Utils.vala"
			_tmp9_ = pixbuf;
#line 376 "../lib/Utils.vala"
			_tmp10_ = pixbuf;
#line 376 "../lib/Utils.vala"
			_tmp11_ = pixbuf;
#line 376 "../lib/Utils.vala"
			_tmp12_ = pixbuf;
#line 376 "../lib/Utils.vala"
			clutter_texture_set_from_rgb_data (_tmp6_, _tmp8_, gdk_pixbuf_get_has_alpha (_tmp9_), gdk_pixbuf_get_width (_tmp10_), gdk_pixbuf_get_height (_tmp11_), gdk_pixbuf_get_rowstride (_tmp12_), _tmp4_, 0, &_inner_error_);
#line 376 "../lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2078 "Utils.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
#line 375 "../lib/Utils.vala"
			e = _inner_error_;
#line 375 "../lib/Utils.vala"
			_inner_error_ = NULL;
#line 375 "../lib/Utils.vala"
			_g_error_free0 (e);
#line 2092 "Utils.c"
		}
		__finally4:
#line 375 "../lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 375 "../lib/Utils.vala"
			_g_object_unref0 (pixbuf);
#line 375 "../lib/Utils.vala"
			_g_object_unref0 (texture);
#line 375 "../lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 375 "../lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 375 "../lib/Utils.vala"
			return NULL;
#line 2107 "Utils.c"
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp13_;
		MetaSettings* _tmp14_;
		ClutterTexture* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		ClutterTexture* _tmp18_;
		ClutterColor _tmp19_ = {0};
#line 385 "../lib/Utils.vala"
		_tmp13_ = meta_get_backend ();
#line 385 "../lib/Utils.vala"
		_tmp14_ = meta_backend_get_settings (_tmp13_);
#line 385 "../lib/Utils.vala"
		scale = meta_settings_get_ui_scaling_factor (_tmp14_);
#line 389 "../lib/Utils.vala"
		_tmp15_ = texture;
#line 389 "../lib/Utils.vala"
		_tmp16_ = scale;
#line 389 "../lib/Utils.vala"
		_tmp17_ = scale;
#line 389 "../lib/Utils.vala"
		clutter_actor_set_size ((ClutterActor*) _tmp15_, (gfloat) (36 * _tmp16_), (gfloat) (36 * _tmp17_));
#line 390 "../lib/Utils.vala"
		_tmp18_ = texture;
#line 390 "../lib/Utils.vala"
		_tmp19_.red = (guint8) 255;
#line 390 "../lib/Utils.vala"
		_tmp19_.green = (guint8) 0;
#line 390 "../lib/Utils.vala"
		_tmp19_.blue = (guint8) 0;
#line 390 "../lib/Utils.vala"
		_tmp19_.alpha = (guint8) 255;
#line 390 "../lib/Utils.vala"
		clutter_actor_set_background_color ((ClutterActor*) _tmp18_, &_tmp19_);
#line 2144 "Utils.c"
	}
#line 393 "../lib/Utils.vala"
	result = (ClutterActor*) texture;
#line 393 "../lib/Utils.vala"
	_g_object_unref0 (pixbuf);
#line 393 "../lib/Utils.vala"
	return result;
#line 2152 "Utils.c"
}


static void
_g_free0_ (gpointer var)
{
#line 32 "../lib/Utils.vala"
	var = (g_free (var), NULL);
#line 2161 "Utils.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 32 "../lib/Utils.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2170 "Utils.c"
}


static void
gala_value_utils_init (GValue* value)
{
#line 20 "../lib/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 2179 "Utils.c"
}


static void
gala_value_utils_free_value (GValue* value)
{
#line 20 "../lib/Utils.vala"
	if (value->data[0].v_pointer) {
#line 20 "../lib/Utils.vala"
		gala_utils_unref (value->data[0].v_pointer);
#line 2190 "Utils.c"
	}
}


static void
gala_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 20 "../lib/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../lib/Utils.vala"
		dest_value->data[0].v_pointer = gala_utils_ref (src_value->data[0].v_pointer);
#line 2203 "Utils.c"
	} else {
#line 20 "../lib/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2207 "Utils.c"
	}
}


static gpointer
gala_value_utils_peek_pointer (const GValue* value)
{
#line 20 "../lib/Utils.vala"
	return value->data[0].v_pointer;
#line 2217 "Utils.c"
}


static gchar*
gala_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 20 "../lib/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 2229 "Utils.c"
		GalaUtils * object;
		object = collect_values[0].v_pointer;
#line 20 "../lib/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../lib/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2236 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../lib/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2240 "Utils.c"
		}
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = gala_utils_ref (object);
#line 2244 "Utils.c"
	} else {
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2248 "Utils.c"
	}
#line 20 "../lib/Utils.vala"
	return NULL;
#line 2252 "Utils.c"
}


static gchar*
gala_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	GalaUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../lib/Utils.vala"
	if (!object_p) {
#line 20 "../lib/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2268 "Utils.c"
	}
#line 20 "../lib/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../lib/Utils.vala"
		*object_p = NULL;
#line 2274 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../lib/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 2278 "Utils.c"
	} else {
#line 20 "../lib/Utils.vala"
		*object_p = gala_utils_ref (value->data[0].v_pointer);
#line 2282 "Utils.c"
	}
#line 20 "../lib/Utils.vala"
	return NULL;
#line 2286 "Utils.c"
}


GParamSpec*
gala_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	GalaParamSpecUtils* spec;
#line 20 "../lib/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_UTILS), NULL);
#line 20 "../lib/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../lib/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../lib/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 2306 "Utils.c"
}


gpointer
gala_value_get_utils (const GValue* value)
{
#line 20 "../lib/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS), NULL);
#line 20 "../lib/Utils.vala"
	return value->data[0].v_pointer;
#line 2317 "Utils.c"
}


void
gala_value_set_utils (GValue* value,
                      gpointer v_object)
{
	GalaUtils * old;
#line 20 "../lib/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
#line 20 "../lib/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "../lib/Utils.vala"
	if (v_object) {
#line 20 "../lib/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
#line 20 "../lib/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../lib/Utils.vala"
		gala_utils_ref (value->data[0].v_pointer);
#line 2340 "Utils.c"
	} else {
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2344 "Utils.c"
	}
#line 20 "../lib/Utils.vala"
	if (old) {
#line 20 "../lib/Utils.vala"
		gala_utils_unref (old);
#line 2350 "Utils.c"
	}
}


void
gala_value_take_utils (GValue* value,
                       gpointer v_object)
{
	GalaUtils * old;
#line 20 "../lib/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
#line 20 "../lib/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "../lib/Utils.vala"
	if (v_object) {
#line 20 "../lib/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
#line 20 "../lib/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 2372 "Utils.c"
	} else {
#line 20 "../lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2376 "Utils.c"
	}
#line 20 "../lib/Utils.vala"
	if (old) {
#line 20 "../lib/Utils.vala"
		gala_utils_unref (old);
#line 2382 "Utils.c"
	}
}


static void
gala_utils_class_init (GalaUtilsClass * klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
#line 20 "../lib/Utils.vala"
	gala_utils_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/Utils.vala"
	((GalaUtilsClass *) klass)->finalize = gala_utils_finalize;
#line 32 "../lib/Utils.vala"
	_tmp0_ = g_str_hash;
#line 32 "../lib/Utils.vala"
	_tmp1_ = g_str_equal;
#line 32 "../lib/Utils.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 32 "../lib/Utils.vala"
	_g_hash_table_unref0 (gala_utils_xid_pixbuf_cache);
#line 32 "../lib/Utils.vala"
	gala_utils_xid_pixbuf_cache = _tmp2_;
#line 33 "../lib/Utils.vala"
	_tmp3_ = g_str_hash;
#line 33 "../lib/Utils.vala"
	_tmp4_ = g_str_equal;
#line 33 "../lib/Utils.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
#line 33 "../lib/Utils.vala"
	_g_hash_table_unref0 (gala_utils_icon_pixbuf_cache);
#line 33 "../lib/Utils.vala"
	gala_utils_icon_pixbuf_cache = _tmp5_;
#line 2420 "Utils.c"
}


static void
gala_utils_instance_init (GalaUtils * self)
{
#line 20 "../lib/Utils.vala"
	self->ref_count = 1;
#line 2429 "Utils.c"
}


static void
gala_utils_finalize (GalaUtils * obj)
{
	GalaUtils * self;
#line 20 "../lib/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_UTILS, GalaUtils);
#line 20 "../lib/Utils.vala"
	g_signal_handlers_destroy (self);
#line 2441 "Utils.c"
}


GType
gala_utils_get_type (void)
{
	static volatile gsize gala_utils_type_id__volatile = 0;
	if (g_once_init_enter (&gala_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_utils_init, gala_value_utils_free_value, gala_value_utils_copy_value, gala_value_utils_peek_pointer, "p", gala_value_utils_collect_value, "p", gala_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaUtils), 0, (GInstanceInitFunc) gala_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_utils_type_id;
		gala_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gala_utils_type_id__volatile, gala_utils_type_id);
	}
	return gala_utils_type_id__volatile;
}


gpointer
gala_utils_ref (gpointer instance)
{
	GalaUtils * self;
	self = instance;
#line 20 "../lib/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../lib/Utils.vala"
	return instance;
#line 2470 "Utils.c"
}


void
gala_utils_unref (gpointer instance)
{
	GalaUtils * self;
	self = instance;
#line 20 "../lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../lib/Utils.vala"
		GALA_UTILS_GET_CLASS (self)->finalize (self);
#line 20 "../lib/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2485 "Utils.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



